力扣热门100题之矩阵置零

这道题要求不能用额外空间 ,必须用矩阵第一行、第一列当作标记位,是面试高频题!

核心思路(原地算法)

  1. 用第一行、第一列本身记录哪些行、哪些列需要置 0
  2. 先单独判断第一行、第一列本身是否有 0
  3. 遍历其他元素,遇到 0 就标记到第一行对应列 、第一列对应行
  4. 根据标记把对应行、列置 0
  5. 最后处理第一行、第一列

超级通俗大白话解释

1. 为什么要单独标记第一行、第一列?

因为第一行、第一列要用来当标记位,不能先把它们直接置 0,否则会丢失原本的标记信息。

2. 核心标记规则

  • 如果 matrix[i][j] = 0
  • 就让 第一行第 j 列 = 0(表示这一列要清零)
  • 就让 第 i 行第一列 = 0(表示这一行要清零)

3. 最后清零

  • 看第一列 → 哪行标 0 → 整行清零
  • 看第一行 → 哪列标 0 → 整列清零
  • 最后根据一开始记录的 firstRow、firstCol 清零第一行、第一列

完整代码实现

java 复制代码
class Solution {
    public void setZeroes(int[][] matrix) {
        int m = matrix.length; // 行数
        int n = matrix[0].length; //列数

        // 标记:第一行是否有 0
        boolean firstRow = false;
        // 标记:第一列是否有 0
        boolean firstCol = false;

        // 检查第一行是否有0
        for (int j = 0; j < matrix[0].length; j++) {
            if (matrix[0][j] == 0) {
                firstRow = true;
                break;
            }
        }

        // 检查第一列是否有0
        for (int i = 0; i < matrix.length; i++) {
            if (matrix[i][0] == 0) {
                firstCol = true;
                break;
            }
        }

        // 3. 遍历除第一行、第一列外的元素
        // 如果 matrix[i][j] == 0,就标记到第一行和第一列
        for (int i = 1; i < m; i++) {
            for (int j = 1; j < n; j++) {
                if (matrix[i][j] == 0) {
                    matrix[i][0] = 0; // 标记第 i 行需要置 0
                    matrix[0][j] = 0; // 标记第 j 列需要置 0
                }
            }
        }

        // 4. 根据第一列的标记,把对应行置为0
        for (int i = 1; i < m; i++) {
            if (matrix[i][0] == 0) {
                for (int j = 1; j < n; j++) {
                    matrix[i][j] = 0;
                }
            }
        }

        // 根据第一行的标记 把对应列置为0
        for(int j = 1; j < n; j++){
            if(matrix[0][j] == 0){
                for(int i = 1;i<m;i++){
                    matrix[i][j] = 0;
                }
            }
        }

        //最后处理第一行
        if(firstRow){
            for(int j = 0;j<n;j++){
                matrix[0][j] = 0;
            }
        }

        //处理第一列
        if(firstCol){
            for(int i = 0;i<m;i++){
                matrix[i][0] = 0;
            }
        }
    }
}
相关推荐
hanlin036 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.6 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
碧海银沙音频科技研究院9 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI9 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo6239 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y9 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu9 小时前
笛卡尔树
算法·图论
026d239 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生10 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生10 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构